<?php

namespace Drupal\email_message\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\text\Plugin\Field\FieldWidget\TextareaWidget;

/**
 * Plugin implementation of the 'email_message_default' widget.
 *
 * @FieldWidget(
 *   id = "email_message_default",
 *   label = @Translation("Email message default"),
 *   field_types = {
 *     "email_message"
 *   },
 * )
 */
class EmailMessageDefaultWidget extends TextareaWidget {



  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state): array {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

    // Wrap elements with a fieldset.
    $element['#theme_wrappers'][] = 'fieldset';

    $element['#title'] = $this->t('Email body');
    $element['#title_display'] = 'before';

    $element['subject'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Email subject'),
      '#default_value' => $items[$delta]->subject,
      '#weight' => -10,
    ];
    return $element;
  }
}
